

' VBA declare statements for NAG Fortran Library DLL Mark 28.7
' Copyright 2022, Numerical Algorithms Group Ltd, Oxford, UK.
' chapter f10

   Declare Ptrsafe Sub F10CAF Lib "NLW32287E_nag.dll" ( _
    ByVal jobu As string, ByVal jobulength As long, _
    ByVal jobvt As string, ByVal jobvtlength As long, _
    ByRef m As long, _
    ByRef n As long, _
    ByRef a As double, _
    ByRef lda As long, _
    ByRef k As long, _
    ByRef rtol_abs As double, _
    ByRef rtol_rel As double, _
    ByRef state As long, _
    ByRef s As double, _
    ByRef u As double, _
    ByRef ldu As long, _
    ByRef vt As double, _
    ByRef ldvt As long, _
    ByRef r As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F10DAF Lib "NLW32287E_nag.dll" ( _
    ByVal trans As string, ByVal translength As long, _
    ByRef m As long, _
    ByRef n As long, _
    ByRef a As double, _
    ByRef lda As long, _
    ByRef k As long, _
    ByRef state As long, _
    ByRef ifail As long _
   )


' chapter f11

   Declare Ptrsafe Sub F11BDF Lib "NLW32287E_nag.dll" ( _
    ByVal method As string, ByVal methodlength As long, _
    ByVal precon As string, ByVal preconlength As long, _
    ByVal norm As string, ByVal normlength As long, _
    ByVal weight As string, ByVal weightlength As long, _
    ByRef iterm As long, _
    ByRef n As long, _
    ByRef m As long, _
    ByRef tol As double, _
    ByRef maxitn As long, _
    ByRef anorm As double, _
    ByRef sigmax As double, _
    ByRef monit As long, _
    ByRef lwreq As long, _
    ByRef work As double, _
    ByRef lwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11BEF Lib "NLW32287E_nag.dll" ( _
    ByRef irevcm As long, _
    ByRef u As double, _
    ByRef v As double, _
    ByRef wgt As double, _
    ByRef work As double, _
    ByRef lwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11BFF Lib "NLW32287E_nag.dll" ( _
    ByRef itn As long, _
    ByRef stplhs As double, _
    ByRef stprhs As double, _
    ByRef anorm As double, _
    ByRef sigmax As double, _
    ByRef work As double, _
    ByRef lwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11BRF Lib "NLW32287E_nag.dll" ( _
    ByVal method As string, ByVal methodlength As long, _
    ByVal precon As string, ByVal preconlength As long, _
    ByVal norm As string, ByVal normlength As long, _
    ByVal weight As string, ByVal weightlength As long, _
    ByRef iterm As long, _
    ByRef n As long, _
    ByRef m As long, _
    ByRef tol As double, _
    ByRef maxitn As long, _
    ByRef anorm As double, _
    ByRef sigmax As double, _
    ByRef monit As long, _
    ByRef lwreq As long, _
    ByRef work As Complex, _
    ByRef lwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11BSF Lib "NLW32287E_nag.dll" ( _
    ByRef irevcm As long, _
    ByRef u As Complex, _
    ByRef v As Complex, _
    ByRef wgt As double, _
    ByRef work As Complex, _
    ByRef lwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11BTF Lib "NLW32287E_nag.dll" ( _
    ByRef itn As long, _
    ByRef stplhs As double, _
    ByRef stprhs As double, _
    ByRef anorm As double, _
    ByRef sigmax As double, _
    ByRef work As Complex, _
    ByRef lwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11DAF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As double, _
    ByRef la As long, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef lfill As long, _
    ByRef dtol As double, _
    ByVal pstrat As string, ByVal pstratlength As long, _
    ByVal milu As string, ByVal milulength As long, _
    ByRef ipivp As long, _
    ByRef ipivq As long, _
    ByRef istr As long, _
    ByRef idiag As long, _
    ByRef nnzc As long, _
    ByRef npivm As long, _
    ByRef iwork As long, _
    ByRef liwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11DBF Lib "NLW32287E_nag.dll" ( _
    ByVal trans As string, ByVal translength As long, _
    ByRef n As long, _
    ByRef a As double, _
    ByRef la As long, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef ipivp As long, _
    ByRef ipivq As long, _
    ByRef istr As long, _
    ByRef idiag As long, _
    ByVal check As string, ByVal checklength As long, _
    ByRef y As double, _
    ByRef x As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11DCF Lib "NLW32287E_nag.dll" ( _
    ByVal method As string, ByVal methodlength As long, ByRef n As long, ByRef nnz As long, _
    ByRef a As double, ByRef la As long, ByRef irow As long, _
    ByRef icol As long, ByRef ipivp As long, ByRef ipivq As long, _
    ByRef istr As long, ByRef idiag As long, ByRef b As double, _
    ByRef m As long, ByRef tol As double, ByRef maxitn As long, _
    ByRef x As double, ByRef rnorm As double, ByRef itn As long, _
    ByRef work As double, ByRef lwork As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11DDF Lib "NLW32287E_nag.dll" ( _
    ByVal trans As string, ByVal translength As long, _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As double, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef rdiag As double, _
    ByRef omega As double, _
    ByVal check As string, ByVal checklength As long, _
    ByRef y As double, _
    ByRef x As double, _
    ByRef iwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11DEF Lib "NLW32287E_nag.dll" ( _
    ByVal method As string, ByVal methodlength As long, _
    ByVal precon As string, ByVal preconlength As long, _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As double, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef omega As double, _
    ByRef b As double, _
    ByRef m As long, _
    ByRef tol As double, _
    ByRef maxitn As long, _
    ByRef x As double, _
    ByRef rnorm As double, _
    ByRef itn As long, _
    ByRef work As double, _
    ByRef lwork As long, _
    ByRef iwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11DFF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, ByRef nnz As long, ByRef a As double, _
    ByRef la As long, ByRef irow As long, ByRef icol As long, _
    ByRef nb As long, ByRef istb As long, ByRef indb As long, _
    ByRef lindb As long, ByRef lfill As long, ByRef dtol As double, _
    ByVal pstrat As string, ByVal pstratlength As long, ByVal milu As string, ByVal milulength As long, ByRef ipivp As long, _
    ByRef ipivq As long, ByRef istr As long, ByRef idiag As long, _
    ByRef nnzc As long, ByRef npivm As long, ByRef iwork As long, _
    ByRef liwork As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11DGF Lib "NLW32287E_nag.dll" ( _
    ByVal method As string, ByVal methodlength As long, ByRef n As long, ByRef nnz As long, _
    ByRef a As double, ByRef la As long, ByRef irow As long, _
    ByRef icol As long, ByRef nb As long, ByRef istb As long, _
    ByRef indb As long, ByRef lindb As long, ByRef ipivp As long, _
    ByRef ipivq As long, ByRef istr As long, ByRef idiag As long, _
    ByRef b As double, ByRef m As long, ByRef tol As double, _
    ByRef maxitn As long, ByRef x As double, ByRef rnorm As double, _
    ByRef itn As long, ByRef work As double, ByRef lwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11DKF Lib "NLW32287E_nag.dll" ( _
    ByVal store As string, ByVal storelength As long, _
    ByVal trans As string, ByVal translength As long, _
    ByVal init As string, ByVal initlength As long, _
    ByRef niter As long, _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As double, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByVal check As string, ByVal checklength As long, _
    ByRef b As double, _
    ByRef x As double, _
    ByRef diag As double, _
    ByRef work As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11DNF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As Complex, _
    ByRef la As long, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef lfill As long, _
    ByRef dtol As double, _
    ByVal pstrat As string, ByVal pstratlength As long, _
    ByVal milu As string, ByVal milulength As long, _
    ByRef ipivp As long, _
    ByRef ipivq As long, _
    ByRef istr As long, _
    ByRef idiag As long, _
    ByRef nnzc As long, _
    ByRef npivm As long, _
    ByRef iwork As long, _
    ByRef liwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11DPF Lib "NLW32287E_nag.dll" ( _
    ByVal trans As string, ByVal translength As long, _
    ByRef n As long, _
    ByRef a As Complex, _
    ByRef la As long, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef ipivp As long, _
    ByRef ipivq As long, _
    ByRef istr As long, _
    ByRef idiag As long, _
    ByVal check As string, ByVal checklength As long, _
    ByRef y As Complex, _
    ByRef x As Complex, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11DQF Lib "NLW32287E_nag.dll" ( _
    ByVal method As string, ByVal methodlength As long, ByRef n As long, ByRef nnz As long, _
    ByRef a As Complex, ByRef la As long, ByRef irow As long, _
    ByRef icol As long, ByRef ipivp As long, ByRef ipivq As long, _
    ByRef istr As long, ByRef idiag As long, ByRef b As Complex, _
    ByRef m As long, ByRef tol As double, ByRef maxitn As long, _
    ByRef x As Complex, ByRef rnorm As double, ByRef itn As long, _
    ByRef work As Complex, ByRef lwork As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11DRF Lib "NLW32287E_nag.dll" ( _
    ByVal trans As string, ByVal translength As long, _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As Complex, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef rdiag As Complex, _
    ByRef omega As double, _
    ByVal check As string, ByVal checklength As long, _
    ByRef y As Complex, _
    ByRef x As Complex, _
    ByRef iwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11DSF Lib "NLW32287E_nag.dll" ( _
    ByVal method As string, ByVal methodlength As long, _
    ByVal precon As string, ByVal preconlength As long, _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As Complex, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef omega As double, _
    ByRef b As Complex, _
    ByRef m As long, _
    ByRef tol As double, _
    ByRef maxitn As long, _
    ByRef x As Complex, _
    ByRef rnorm As double, _
    ByRef itn As long, _
    ByRef work As Complex, _
    ByRef lwork As long, _
    ByRef iwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11DTF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, ByRef nnz As long, ByRef a As Complex, _
    ByRef la As long, ByRef irow As long, ByRef icol As long, _
    ByRef nb As long, ByRef istb As long, ByRef indb As long, _
    ByRef lindb As long, ByRef lfill As long, ByRef dtol As double, _
    ByVal pstrat As string, ByVal pstratlength As long, ByVal milu As string, ByVal milulength As long, ByRef ipivp As long, _
    ByRef ipivq As long, ByRef istr As long, ByRef idiag As long, _
    ByRef nnzc As long, ByRef npivm As long, ByRef iwork As long, _
    ByRef liwork As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11DUF Lib "NLW32287E_nag.dll" ( _
    ByVal method As string, ByVal methodlength As long, ByRef n As long, ByRef nnz As long, _
    ByRef a As Complex, ByRef la As long, ByRef irow As long, _
    ByRef icol As long, ByRef nb As long, ByRef istb As long, _
    ByRef indb As long, ByRef lindb As long, ByRef ipivp As long, _
    ByRef ipivq As long, ByRef istr As long, ByRef idiag As long, _
    ByRef b As Complex, ByRef m As long, ByRef tol As double, _
    ByRef maxitn As long, ByRef x As Complex, ByRef rnorm As double, _
    ByRef itn As long, ByRef work As Complex, ByRef lwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11DXF Lib "NLW32287E_nag.dll" ( _
    ByVal store As string, ByVal storelength As long, _
    ByVal trans As string, ByVal translength As long, _
    ByVal init As string, ByVal initlength As long, _
    ByRef niter As long, _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As Complex, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByVal check As string, ByVal checklength As long, _
    ByRef b As Complex, _
    ByRef x As Complex, _
    ByRef diag As Complex, _
    ByRef work As Complex, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11GDF Lib "NLW32287E_nag.dll" ( _
    ByVal method As string, ByVal methodlength As long, _
    ByVal precon As string, ByVal preconlength As long, _
    ByVal sigcmp As string, ByVal sigcmplength As long, _
    ByVal norm As string, ByVal normlength As long, _
    ByVal weight As string, ByVal weightlength As long, _
    ByRef iterm As long, _
    ByRef n As long, _
    ByRef tol As double, _
    ByRef maxitn As long, _
    ByRef anorm As double, _
    ByRef sigmax As double, _
    ByRef sigtol As double, _
    ByRef maxits As long, _
    ByRef monit As long, _
    ByRef lwreq As long, _
    ByRef work As double, _
    ByRef lwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11GEF Lib "NLW32287E_nag.dll" ( _
    ByRef irevcm As long, _
    ByRef u As double, _
    ByRef v As double, _
    ByRef wgt As double, _
    ByRef work As double, _
    ByRef lwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11GFF Lib "NLW32287E_nag.dll" ( _
    ByRef itn As long, _
    ByRef stplhs As double, _
    ByRef stprhs As double, _
    ByRef anorm As double, _
    ByRef sigmax As double, _
    ByRef its As long, _
    ByRef sigerr As double, _
    ByRef work As double, _
    ByRef lwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11GRF Lib "NLW32287E_nag.dll" ( _
    ByVal method As string, ByVal methodlength As long, _
    ByVal precon As string, ByVal preconlength As long, _
    ByVal sigcmp As string, ByVal sigcmplength As long, _
    ByVal norm As string, ByVal normlength As long, _
    ByVal weight As string, ByVal weightlength As long, _
    ByRef iterm As long, _
    ByRef n As long, _
    ByRef tol As double, _
    ByRef maxitn As long, _
    ByRef anorm As double, _
    ByRef sigmax As double, _
    ByRef sigtol As double, _
    ByRef maxits As long, _
    ByRef monit As long, _
    ByRef lwreq As long, _
    ByRef work As Complex, _
    ByRef lwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11GSF Lib "NLW32287E_nag.dll" ( _
    ByRef irevcm As long, _
    ByRef u As Complex, _
    ByRef v As Complex, _
    ByRef wgt As double, _
    ByRef work As Complex, _
    ByRef lwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11GTF Lib "NLW32287E_nag.dll" ( _
    ByRef itn As long, _
    ByRef stplhs As double, _
    ByRef stprhs As double, _
    ByRef anorm As double, _
    ByRef sigmax As double, _
    ByRef its As long, _
    ByRef sigerr As double, _
    ByRef work As Complex, _
    ByRef lwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11JAF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As double, _
    ByRef la As long, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef lfill As long, _
    ByRef dtol As double, _
    ByVal mic As string, ByVal miclength As long, _
    ByRef dscale As double, _
    ByVal pstrat As string, ByVal pstratlength As long, _
    ByRef ipiv As long, _
    ByRef istr As long, _
    ByRef nnzc As long, _
    ByRef npivm As long, _
    ByRef iwork As long, _
    ByRef liwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11JBF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef a As double, _
    ByRef la As long, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef ipiv As long, _
    ByRef istr As long, _
    ByVal check As string, ByVal checklength As long, _
    ByRef y As double, _
    ByRef x As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11JCF Lib "NLW32287E_nag.dll" ( _
    ByVal method As string, ByVal methodlength As long, _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As double, _
    ByRef la As long, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef ipiv As long, _
    ByRef istr As long, _
    ByRef b As double, _
    ByRef tol As double, _
    ByRef maxitn As long, _
    ByRef x As double, _
    ByRef rnorm As double, _
    ByRef itn As long, _
    ByRef work As double, _
    ByRef lwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11JDF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As double, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef rdiag As double, _
    ByRef omega As double, _
    ByVal check As string, ByVal checklength As long, _
    ByRef y As double, _
    ByRef x As double, _
    ByRef iwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11JEF Lib "NLW32287E_nag.dll" ( _
    ByVal method As string, ByVal methodlength As long, _
    ByVal precon As string, ByVal preconlength As long, _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As double, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef omega As double, _
    ByRef b As double, _
    ByRef tol As double, _
    ByRef maxitn As long, _
    ByRef x As double, _
    ByRef rnorm As double, _
    ByRef itn As long, _
    ByRef work As double, _
    ByRef lwork As long, _
    ByRef iwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11JNF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As Complex, _
    ByRef la As long, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef lfill As long, _
    ByRef dtol As double, _
    ByVal mic As string, ByVal miclength As long, _
    ByRef dscale As double, _
    ByVal pstrat As string, ByVal pstratlength As long, _
    ByRef ipiv As long, _
    ByRef istr As long, _
    ByRef nnzc As long, _
    ByRef npivm As long, _
    ByRef iwork As long, _
    ByRef liwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11JPF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef a As Complex, _
    ByRef la As long, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef ipiv As long, _
    ByRef istr As long, _
    ByVal check As string, ByVal checklength As long, _
    ByRef y As Complex, _
    ByRef x As Complex, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11JQF Lib "NLW32287E_nag.dll" ( _
    ByVal method As string, ByVal methodlength As long, _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As Complex, _
    ByRef la As long, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef ipiv As long, _
    ByRef istr As long, _
    ByRef b As Complex, _
    ByRef tol As double, _
    ByRef maxitn As long, _
    ByRef x As Complex, _
    ByRef rnorm As double, _
    ByRef itn As long, _
    ByRef work As Complex, _
    ByRef lwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11JRF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As Complex, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef rdiag As double, _
    ByRef omega As double, _
    ByVal check As string, ByVal checklength As long, _
    ByRef y As Complex, _
    ByRef x As Complex, _
    ByRef iwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11JSF Lib "NLW32287E_nag.dll" ( _
    ByVal method As string, ByVal methodlength As long, _
    ByVal precon As string, ByVal preconlength As long, _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As Complex, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef omega As double, _
    ByRef b As Complex, _
    ByRef tol As double, _
    ByRef maxitn As long, _
    ByRef x As Complex, _
    ByRef rnorm As double, _
    ByRef itn As long, _
    ByRef rdiag As double, _
    ByRef work As Complex, _
    ByRef lwork As long, _
    ByRef iwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11MDF Lib "NLW32287E_nag.dll" ( _
    ByVal spec As string, ByVal speclength As long, _
    ByRef n As long, _
    ByRef icolzp As long, _
    ByRef irowix As long, _
    ByRef iprm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11MEF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef irowix As long, _
    ByRef a As double, _
    ByRef iprm As long, _
    ByRef thresh As double, _
    ByRef nzlmx As long, _
    ByRef nzlumx As long, _
    ByRef nzumx As long, _
    ByRef il As long, _
    ByRef lval As double, _
    ByRef iu As long, _
    ByRef uval As double, _
    ByRef nnzl As long, _
    ByRef nnzu As long, _
    ByRef flop As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11MFF Lib "NLW32287E_nag.dll" ( _
    ByVal trans As string, ByVal translength As long, _
    ByRef n As long, _
    ByRef iprm As long, _
    ByRef il As long, _
    ByRef lval As double, _
    ByRef iu As long, _
    ByRef uval As double, _
    ByRef nrhs As long, _
    ByRef b As double, _
    ByRef ldb As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11MGF Lib "NLW32287E_nag.dll" ( _
    ByVal norm As string, ByVal normlength As long, _
    ByRef n As long, _
    ByRef il As long, _
    ByRef lval As double, _
    ByRef iu As long, _
    ByRef uval As double, _
    ByRef anorm As double, _
    ByRef rcond As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11MHF Lib "NLW32287E_nag.dll" ( _
    ByVal trans As string, ByVal translength As long, _
    ByRef n As long, _
    ByRef icolzp As long, _
    ByRef irowix As long, _
    ByRef a As double, _
    ByRef iprm As long, _
    ByRef il As long, _
    ByRef lval As double, _
    ByRef iu As long, _
    ByRef uval As double, _
    ByRef nrhs As long, _
    ByRef b As double, _
    ByRef ldb As long, _
    ByRef x As double, _
    ByRef ldx As long, _
    ByRef ferr As double, _
    ByRef berr As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11MKF Lib "NLW32287E_nag.dll" ( _
    ByVal trans As string, ByVal translength As long, _
    ByRef n As long, _
    ByRef m As long, _
    ByRef alpha As double, _
    ByRef icolzp As long, _
    ByRef irowix As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef ldb As long, _
    ByRef beta As double, _
    ByRef c As double, _
    ByRef ldc As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11MLF Lib "NLW32287E_nag.dll" ( _
    ByVal norm As string, ByVal normlength As long, _
    ByRef anorm As double, _
    ByRef n As long, _
    ByRef icolzp As long, _
    ByRef irowix As long, _
    ByRef a As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11MMF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef icolzp As long, _
    ByRef a As double, _
    ByRef iprm As long, _
    ByRef il As long, _
    ByRef lval As double, _
    ByRef iu As long, _
    ByRef uval As double, _
    ByRef rpg As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11XAF Lib "NLW32287E_nag.dll" ( _
    ByVal trans As string, ByVal translength As long, _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As double, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByVal check As string, ByVal checklength As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11XEF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As double, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByVal check As string, ByVal checklength As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11XNF Lib "NLW32287E_nag.dll" ( _
    ByVal trans As string, ByVal translength As long, _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As Complex, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByVal check As string, ByVal checklength As long, _
    ByRef x As Complex, _
    ByRef y As Complex, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11XSF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As Complex, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByVal check As string, ByVal checklength As long, _
    ByRef x As Complex, _
    ByRef y As Complex, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11YEF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef icolzp As long, _
    ByRef irowix As long, _
    ByRef lopts As long, _
    ByRef mask As long, _
    ByRef perm As long, _
    ByRef info As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11ZAF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As double, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByVal dup As string, ByVal duplength As long, _
    ByVal zer As string, ByVal zerlength As long, _
    ByRef istr As long, _
    ByRef iwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11ZBF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As double, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByVal dup As string, ByVal duplength As long, _
    ByVal zer As string, ByVal zerlength As long, _
    ByRef istr As long, _
    ByRef iwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11ZCF Lib "NLW32287E_nag.dll" ( _
    ByRef m As long, _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As double, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef istc As long, _
    ByRef store As long, _
    ByVal dup As string, ByVal duplength As long, _
    ByVal zer As string, ByVal zerlength As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11ZNF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As Complex, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByVal dup As string, ByVal duplength As long, _
    ByVal zer As string, ByVal zerlength As long, _
    ByRef istr As long, _
    ByRef iwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F11ZPF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nnz As long, _
    ByRef a As Complex, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByVal dup As string, ByVal duplength As long, _
    ByVal zer As string, ByVal zerlength As long, _
    ByRef istr As long, _
    ByRef iwork As long, _
    ByRef ifail As long _
   )


' chapter f12

   Declare Ptrsafe Sub F12AAF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nev As long, _
    ByRef ncv As long, _
    ByRef icomm As long, _
    ByRef licomm As long, _
    ByRef comm As double, _
    ByRef lcomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12ABF Lib "NLW32287E_nag.dll" ( _
    ByRef irevcm As long, _
    ByRef resid As double, _
    ByRef v As double, _
    ByRef ldv As long, _
    ByRef x As double, _
    ByRef mx As double, _
    ByRef nshift As long, _
    ByRef comm As double, _
    ByRef icomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12ACF Lib "NLW32287E_nag.dll" ( _
    ByRef nconv As long, _
    ByRef dr As double, _
    ByRef di As double, _
    ByRef z As double, _
    ByRef ldz As long, _
    ByRef sigmar As double, _
    ByRef sigmai As double, _
    ByRef resid As double, _
    ByRef v As double, _
    ByRef ldv As long, _
    ByRef comm As double, _
    ByRef icomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12ADF Lib "NLW32287E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long, _
    ByRef icomm As long, _
    ByRef comm As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12AEF Lib "NLW32287E_nag.dll" ( _
    ByRef niter As long, _
    ByRef nconv As long, _
    ByRef ritzr As double, _
    ByRef ritzi As double, _
    ByRef rzest As double, _
    ByRef icomm As long, _
    ByRef comm As double _
   )


   Declare Ptrsafe Sub F12AFF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nev As long, _
    ByRef ncv As long, _
    ByRef icomm As long, _
    ByRef licomm As long, _
    ByRef comm As double, _
    ByRef lcomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12AGF Lib "NLW32287E_nag.dll" ( _
    ByRef kl As long, _
    ByRef ku As long, _
    ByRef ab As double, _
    ByRef ldab As long, _
    ByRef mb As double, _
    ByRef ldmb As long, _
    ByRef sigmar As double, _
    ByRef sigmai As double, _
    ByRef nconv As long, _
    ByRef dr As double, _
    ByRef di As double, _
    ByRef z As double, _
    ByRef ldz As long, _
    ByRef resid As double, _
    ByRef v As double, _
    ByRef ldv As long, _
    ByRef comm As double, _
    ByRef icomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12ANF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nev As long, _
    ByRef ncv As long, _
    ByRef icomm As long, _
    ByRef licomm As long, _
    ByRef comm As Complex, _
    ByRef lcomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12APF Lib "NLW32287E_nag.dll" ( _
    ByRef irevcm As long, _
    ByRef resid As Complex, _
    ByRef v As Complex, _
    ByRef ldv As long, _
    ByRef x As Complex, _
    ByRef mx As Complex, _
    ByRef nshift As long, _
    ByRef comm As Complex, _
    ByRef icomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12AQF Lib "NLW32287E_nag.dll" ( _
    ByRef nconv As long, _
    ByRef d As Complex, _
    ByRef z As Complex, _
    ByRef ldz As long, _
    ByRef sigma As Complex, _
    ByRef resid As Complex, _
    ByRef v As Complex, _
    ByRef ldv As long, _
    ByRef comm As Complex, _
    ByRef icomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12ARF Lib "NLW32287E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long, _
    ByRef icomm As long, _
    ByRef comm As Complex, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12ASF Lib "NLW32287E_nag.dll" ( _
    ByRef niter As long, _
    ByRef nconv As long, _
    ByRef ritz As Complex, _
    ByRef rzest As Complex, _
    ByRef icomm As long, _
    ByRef comm As Complex _
   )


   Declare Ptrsafe Sub F12ATF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nev As long, _
    ByRef ncv As long, _
    ByRef icomm As long, _
    ByRef licomm As long, _
    ByRef comm As Complex, _
    ByRef lcomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12AUF Lib "NLW32287E_nag.dll" ( _
    ByRef kl As long, _
    ByRef ku As long, _
    ByRef ab As Complex, _
    ByRef ldab As long, _
    ByRef mb As Complex, _
    ByRef ldmb As long, _
    ByRef sigma As Complex, _
    ByRef nconv As long, _
    ByRef d As Complex, _
    ByRef z As Complex, _
    ByRef ldz As long, _
    ByRef resid As Complex, _
    ByRef v As Complex, _
    ByRef ldv As long, _
    ByRef comm As Complex, _
    ByRef icomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12FAF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nev As long, _
    ByRef ncv As long, _
    ByRef icomm As long, _
    ByRef licomm As long, _
    ByRef comm As double, _
    ByRef lcomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12FBF Lib "NLW32287E_nag.dll" ( _
    ByRef irevcm As long, _
    ByRef resid As double, _
    ByRef v As double, _
    ByRef ldv As long, _
    ByRef x As double, _
    ByRef mx As double, _
    ByRef nshift As long, _
    ByRef comm As double, _
    ByRef icomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12FCF Lib "NLW32287E_nag.dll" ( _
    ByRef nconv As long, _
    ByRef d As double, _
    ByRef z As double, _
    ByRef ldz As long, _
    ByRef sigma As double, _
    ByRef resid As double, _
    ByRef v As double, _
    ByRef ldv As long, _
    ByRef comm As double, _
    ByRef icomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12FDF Lib "NLW32287E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long, _
    ByRef icomm As long, _
    ByRef comm As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12FEF Lib "NLW32287E_nag.dll" ( _
    ByRef niter As long, _
    ByRef nconv As long, _
    ByRef ritz As double, _
    ByRef rzest As double, _
    ByRef icomm As long, _
    ByRef comm As double _
   )


   Declare Ptrsafe Sub F12FFF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef nev As long, _
    ByRef ncv As long, _
    ByRef icomm As long, _
    ByRef licomm As long, _
    ByRef comm As double, _
    ByRef lcomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12FGF Lib "NLW32287E_nag.dll" ( _
    ByRef kl As long, _
    ByRef ku As long, _
    ByRef ab As double, _
    ByRef ldab As long, _
    ByRef mb As double, _
    ByRef ldmb As long, _
    ByRef sigma As double, _
    ByRef nconv As long, _
    ByRef d As double, _
    ByRef z As double, _
    ByRef ldz As long, _
    ByRef resid As double, _
    ByRef v As double, _
    ByRef ldv As long, _
    ByRef comm As double, _
    ByRef icomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12JAF Lib "NLW32287E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12JBF Lib "NLW32287E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal str As string, ByVal strlength As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12JEF Lib "NLW32287E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef emin As double, _
    ByRef emax As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12JFF Lib "NLW32287E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef emid As Complex, _
    ByRef r As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12JGF Lib "NLW32287E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef ccn As long, _
    ByRef nedge As long, _
    ByRef tedge As long, _
    ByRef zedge As Complex, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12JJF Lib "NLW32287E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef irevcm As long, _
    ByRef ze As Complex, _
    ByRef n As long, _
    ByRef x As double, _
    ByRef ldx As long, _
    ByRef y As Complex, _
    ByRef ldy As long, _
    ByRef m0 As long, _
    ByRef nconv As long, _
    ByRef d As double, _
    ByRef z As double, _
    ByRef ldz As long, _
    ByRef eps As double, _
    ByRef iter As long, _
    ByRef resid As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12JKF Lib "NLW32287E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef irevcm As long, _
    ByRef ze As Complex, _
    ByRef n As long, _
    ByRef x As double, _
    ByRef ldx As long, _
    ByRef y As Complex, _
    ByRef ldy As long, _
    ByRef m0 As long, _
    ByRef nconv As long, _
    ByRef d As Complex, _
    ByRef z As double, _
    ByRef ldz As long, _
    ByRef eps As double, _
    ByRef iter As long, _
    ByRef resid As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12JRF Lib "NLW32287E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef irevcm As long, _
    ByRef ze As Complex, _
    ByRef n As long, _
    ByRef x As Complex, _
    ByRef ldx As long, _
    ByRef y As Complex, _
    ByRef ldy As long, _
    ByRef m0 As long, _
    ByRef nconv As long, _
    ByRef d As double, _
    ByRef z As Complex, _
    ByRef ldz As long, _
    ByRef eps As double, _
    ByRef iter As long, _
    ByRef resid As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12JSF Lib "NLW32287E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef irevcm As long, _
    ByRef ze As Complex, _
    ByRef n As long, _
    ByRef x As Complex, _
    ByRef ldx As long, _
    ByRef y As Complex, _
    ByRef ldy As long, _
    ByRef m0 As long, _
    ByRef nconv As long, _
    ByRef d As Complex, _
    ByRef z As Complex, _
    ByRef ldz As long, _
    ByRef eps As double, _
    ByRef iter As long, _
    ByRef resid As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12JTF Lib "NLW32287E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef irevcm As long, _
    ByRef ze As Complex, _
    ByRef n As long, _
    ByRef x As Complex, _
    ByRef ldx As long, _
    ByRef y As Complex, _
    ByRef ldy As long, _
    ByRef m0 As long, _
    ByRef nconv As long, _
    ByRef d As Complex, _
    ByRef z As Complex, _
    ByRef ldz As long, _
    ByRef eps As double, _
    ByRef iter As long, _
    ByRef resid As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12JUF Lib "NLW32287E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef irevcm As long, _
    ByRef deg As long, _
    ByRef ze As Complex, _
    ByRef n As long, _
    ByRef x As Complex, _
    ByRef ldx As long, _
    ByRef y As Complex, _
    ByRef ldy As long, _
    ByRef k As long, _
    ByRef m0 As long, _
    ByRef nconv As long, _
    ByRef d As Complex, _
    ByRef z As Complex, _
    ByRef ldz As long, _
    ByRef eps As double, _
    ByRef iter As long, _
    ByRef resid As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12JVF Lib "NLW32287E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef irevcm As long, _
    ByRef deg As long, _
    ByRef ze As Complex, _
    ByRef n As long, _
    ByRef x As Complex, _
    ByRef ldx As long, _
    ByRef y As Complex, _
    ByRef ldy As long, _
    ByRef k As long, _
    ByRef m0 As long, _
    ByRef nconv As long, _
    ByRef d As Complex, _
    ByRef z As Complex, _
    ByRef ldz As long, _
    ByRef eps As double, _
    ByRef iter As long, _
    ByRef resid As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub F12JZF Lib "NLW32287E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef ifail As long _
   )


' chapter f16

   Declare Ptrsafe Function F16DLF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As long, _
    ByRef incx As long _
   ) As long


   Declare Ptrsafe Sub F16DNF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As long, _
    ByRef incx As long, _
    ByRef k As long, _
    ByRef i As long _
   )


   Declare Ptrsafe Sub F16DPF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As long, _
    ByRef incx As long, _
    ByRef k As long, _
    ByRef i As long _
   )


   Declare Ptrsafe Sub F16DQF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As long, _
    ByRef incx As long, _
    ByRef k As long, _
    ByRef i As long _
   )


   Declare Ptrsafe Sub F16DRF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As long, _
    ByRef incx As long, _
    ByRef k As long, _
    ByRef i As long _
   )


   Declare Ptrsafe Sub F16EAF Lib "NLW32287E_nag.dll" ( _
    ByRef conj As long, _
    ByRef n As long, _
    ByRef alpha As double, _
    ByRef x As double, _
    ByRef incx As long, _
    ByRef beta As double, _
    ByRef y As double, _
    ByRef incy As long, _
    ByRef r As double _
   )


   Declare Ptrsafe Sub F16ECF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef alpha As double, _
    ByRef x As double, _
    ByRef incx As long, _
    ByRef beta As double, _
    ByRef y As double, _
    ByRef incy As long _
   )


   Declare Ptrsafe Sub F16EHF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef alpha As double, _
    ByRef x As double, _
    ByRef incx As long, _
    ByRef beta As double, _
    ByRef y As double, _
    ByRef incy As long, _
    ByRef w As double, _
    ByRef incw As long _
   )


   Declare Ptrsafe Function F16ELF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As double, _
    ByRef incx As long _
   ) As double


   Declare Ptrsafe Sub F16GCF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef alpha As Complex, _
    ByRef x As Complex, _
    ByRef incx As long, _
    ByRef beta As Complex, _
    ByRef y As Complex, _
    ByRef incy As long _
   )


   Declare Ptrsafe Sub F16GHF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef alpha As Complex, _
    ByRef x As Complex, _
    ByRef incx As long, _
    ByRef beta As Complex, _
    ByRef y As Complex, _
    ByRef incy As long, _
    ByRef w As Complex, _
    ByRef incw As long _
   )


   Declare Ptrsafe Function F16GLF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As Complex, _
    ByRef incx As long _
   ) as Complex


   Declare Ptrsafe Sub F16JNF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As double, _
    ByRef incx As long, _
    ByRef k As long, _
    ByRef r As double _
   )


   Declare Ptrsafe Sub F16JPF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As double, _
    ByRef incx As long, _
    ByRef k As long, _
    ByRef r As double _
   )


   Declare Ptrsafe Sub F16JQF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As double, _
    ByRef incx As long, _
    ByRef k As long, _
    ByRef r As double _
   )


   Declare Ptrsafe Sub F16JRF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As double, _
    ByRef incx As long, _
    ByRef k As long, _
    ByRef r As double _
   )


   Declare Ptrsafe Sub F16JSF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As Complex, _
    ByRef incx As long, _
    ByRef k As long, _
    ByRef r As double _
   )


   Declare Ptrsafe Sub F16JTF Lib "NLW32287E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As Complex, _
    ByRef incx As long, _
    ByRef k As long, _
    ByRef r As double _
   )


   Declare Ptrsafe Function F16RBF Lib "NLW32287E_nag.dll" ( _
    ByRef inorm As long, _
    ByRef m As long, _
    ByRef n As long, _
    ByRef kl As long, _
    ByRef ku As long, _
    ByRef ab As double, _
    ByRef ldab As long _
   ) As double


   Declare Ptrsafe Function F16UBF Lib "NLW32287E_nag.dll" ( _
    ByRef inorm As long, _
    ByRef m As long, _
    ByRef n As long, _
    ByRef kl As long, _
    ByRef ku As long, _
    ByRef ab As Complex, _
    ByRef ldab As long _
   ) As double


